/
githubmirror
/
swtpm
Обзор
Документация
Войти
/
githubmirror
/
swtpm
Код
Запросы
0
Пакеты
0
Релизы
0
Аналитика
Безопасность
master
tests/_test_tpm2_init
133 строки
3 KB
Stefan Berger
tests: Test for expected message receive on NOTIFY_SOCKET
13 мар 2026, 04:27
13 мар 2026, 04:27
4a99496
Код
Авторство
О чём код?
#!/bin/bash # For the license, see the LICENSE file in the root directory. #set -x ROOT=${abs_top_builddir:-$(pwd)/..} TESTDIR=${abs_top_testdir:-$(dirname "$0")} VTPM_NAME="vtpm-test-tpm2-init" SWTPM_DEV_NAME="/dev/${VTPM_NAME}" TPM_PATH="$(mktemp -d)" || exit 1 STATE_FILE=$TPM_PATH/tpm2-00.permall VOLATILE_STATE_FILE=$TPM_PATH/tpm2-00.volatilestate SWTPM_INTERFACE=${SWTPM_INTERFACE:-cuse} SWTPM_CMD_UNIX_PATH=${TPM_PATH}/unix-cmd.sock SWTPM_CTRL_UNIX_PATH=${TPM_PATH}/unix-ctrl.sock NOTIFY_SOCKET=${TPM_PATH}/notify.sock NOTIFY_MSG=${TPM_PATH}/notify.msg function cleanup() { if [ -n "${SWTPM_PID}" ]; then kill_quiet -9 "${SWTPM_PID}" fi if [ -n "${SOCAT_PID}" ]; then kill_quiet -9 "${SOCAT_PID}" fi rm -rf "$TPM_PATH" } trap "cleanup" EXIT source "${TESTDIR}/common" [ "${SWTPM_INTERFACE}" == "cuse" ] && source "${TESTDIR}/test_cuse" rm -f "$STATE_FILE" "$VOLATILE_STATE_FILE" 2>/dev/null if has_seccomp_support "${SWTPM_EXE}"; then SWTPM_TEST_SECCOMP_OPT="--seccomp action=none" fi if socat -h | grep -q UNIX-RECVFROM; then socat "UNIX-RECVFROM:${NOTIFY_SOCKET}" "OPEN:${NOTIFY_MSG},creat" & SOCAT_PID=$! fi TPM_PATH=$TPM_PATH NOTIFY_SOCKET=$NOTIFY_SOCKET \ run_swtpm "${SWTPM_INTERFACE}" --tpm2 display_processes_by_name "swtpm" if ! kill_quiet -0 "${SWTPM_PID}"; then echo "Error: ${SWTPM_INTERFACE} TPM did not start." exit 1 fi # Init the TPM if ! run_swtpm_ioctl "${SWTPM_INTERFACE}" -i; then echo "Error: Could not initialize the ${SWTPM_INTERFACE} TPM." exit 1 fi if [ -n "${SOCAT_PID}" ]; then exp="READY=1" act="$(cat "${NOTIFY_MSG}")" if [ "${act}" != "${exp}" ]; then echo "Error: Did not receive expected message on NOTIFY_SOCKET" echo "expected: ${exp}" echo "actual : ${act}" exit 1 fi echo "INFO: Received '${act}' on NOTIFY_SOCKET" fi if ! kill_quiet -0 "${SWTPM_PID}" 2>/dev/null; then echo "Error: ${SWTPM_INTERFACE} TPM not running anymore after INIT." exit 1 fi # Init the TPM again but make its state file inaccessible; this only # works if the TPM runs as non-rootchmod 000 "${STATE_FILE}" if [ "$(id -u)" != "0" ]; then chmod 000 "${STATE_FILE}" if run_swtpm_ioctl "${SWTPM_INTERFACE}" -i; then echo "Error: Unexpected initialization success of the ${SWTPM_INTERFACE} TPM." exit 1 fi sleep 0.5 if ! kill_quiet -0 "${SWTPM_PID}" 2>/dev/null; then echo "Error: ${SWTPM_INTERFACE} TPM not running anymore after failed INIT." exit 1 fi chmod 664 "${STATE_FILE}" # Init the TPM again; now with state file accessible again if ! run_swtpm_ioctl "${SWTPM_INTERFACE}" -i; then echo "Error: Could not initialize the ${SWTPM_INTERFACE} TPM." exit 1 fi sleep 0.5 if ! kill_quiet -0 "${SWTPM_PID}" 2>/dev/null; then echo "Error: ${SWTPM_INTERFACE} TPM not running anymore after INIT." exit 1 fi fi if ! check_seccomp_profile "${SWTPM_EXE}" "${SWTPM_PID}" 0; then exit 1 fi # Shut down if ! run_swtpm_ioctl "${SWTPM_INTERFACE}" -s; then echo "Error: Could not shut down the ${SWTPM_INTERFACE} TPM." exit 1 fi if wait_process_gone "${SWTPM_PID}" 4; then echo "Error: ${SWTPM_INTERFACE} TPM should not be running anymore." exit 1 fi if [ ! -e "$STATE_FILE" ]; then echo "Error: TPM state file $STATE_FILE does not exist." exit 1 fi echo "OK" exit 0